{-# LANGUAGE NoImplicitPrelude #-}
module Bamboo.View.Widget.Head where

import Bamboo.Helper.Env
import qualified Bamboo.Config.Global as G
import Bamboo.Type.Theme hiding (header)
import qualified Bamboo.Type.State as S
import Bamboo.View.Widget.Helper

html_head state = header << ([meta_tag, title_tag state, favicon_tag, rss_tag state] ++ G.theme.css.map css_link ++ G.theme.js.map js_link )

title_tag state = thetitle << [G.blog_title ++ state.S.resource_title.format_title]
rss_tag state   = rss_link $ rss_url_link_pair state .fst
favicon_tag = favicon_link G.favicon

format_title [] = ""
format_title s = " / " ++ s